/****
 * CSignKeyWndGrid.h
 *
 *	Sign key window grid class for the SignWriter key editor.
 *
 *  Copyright  1996 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/
 
 

#pragma	once					/* Include only once */


#include "CGridSelector.h"
#include "KeyEditConsts.h"




struct CSignKeyWndGrid : CGridSelector {

				/* Key code */
	Byte		itsKeyCode;
	
	
				/* Blink state */
	Boolean		itsOn;
	
	
				/* Initialization */
	void		ISignKeyWndGrid (CView *anEnclosure, CBureaucrat *aSupervisor,
							  	 Byte keyCode);


				/* Selection */
	void		BlinkSelect   (long *maxSleep);
	void	    Deselect      (short item);
	void		HiliteItem    (short theItem, HiliteState state);
	void		Deactivate    (void);
	void		Close		  (void);
	ObjType		SelectionType (void);
	
				
				
				/* Edit commands */
	void		DoCopy  (void);
	void		DoPaste (void);
	void		DoClear (short taskIndex);
	void		DoAdd   (void);

	
				/* Symbol editing */
	void		Setup  (void);
	void		Update (void);
	
	
				/* Symbol commands */
	void		DoChange (void);
	void		DoFill   (void);
	void		DoMirror (void);
	void		DoRotate (void);
	void 		DoCursor (void);
	void		DoSymCommand (Byte keyCode);
	

				/* Drawing */
	void		DrawItem 	 (short theItem, Rect *theBox);
	void		ToggleBox    (short item);
	void		ToggleCursor (short item);
	void		ToggleSelect (short item);
	void		UpdateKeyVar (short keyVar);


				/* Mouse */
	void		DoClick (Point hitPt, short modifierKeys, long when);
	void		DoDoubleClick (void);	


				/* Grid mapping */
	short		ItemToKeyVar (short item);
	short		KeyVarToItem (short keyVar);
	Boolean 	ValidItem (short item); 

};
