
/******************************************************************************
 CSignKeyWndTask.h

  Sign key window task classes for the SignWriter key editor.
		
  Copyright 1996 The Center for Sutton Movement Writing. All rights reserved.
		
 ******************************************************************************/
 
 
#pragma once



#include "CTask.h"						/* Superclass for edit tasks */
#include "CMouseTask.h"					/* Superclass for drag task  */
#include "CSignKeyWndGrid.h"
#include "LongQD.h"
#include "Keys.h"




struct CSignKeyWndClear : CTask {	

	CSignKeyWndGrid  *itsGridPane;	
	
	Byte		itsKeyCode;
	short		itsKeyVar;
	

	void		ISignKeyWndClear (short nameIndex, CSignKeyWndGrid *gridPane, 
											       Byte keyCode, short keyVar);											       
	void		Do   (void);
	void		Undo (void);
};



struct CSignKeyWndPaste : CTask {	
	
	CSignKeyWndGrid  *itsGridPane;	
	
	Byte		itsKeyCode;
	short		itsKeyVar;
	
	
	void		ISignKeyWndPaste (CSignKeyWndGrid *gridPane, 
								  Byte keyCode, short keyVar);		
	
	void		Do   (void);
	void		Undo (void);
};



struct CSignKeyWndAdd : CTask {	
	
	CSignKeyWndGrid  *itsGridPane;	
	
	Byte		itsKeyCode;
	short		itsKeyVar;
	

	void		ISignKeyWndAdd (CSignKeyWndGrid *gridPane,
								Byte keyCode, short keyVar);		
	
	void		Do   (void);
	void		Undo (void);
};



struct CSignKeyWndDrag : CMouseTask {


	CSignKeyWndGrid  *itsGridPane;	
	Byte	 		 *itsBase;
	short			 itsItem;
	LongPt	 		 itsFrame;
	
	
	void		ISignKeyWndDrag (CSignKeyWndGrid *gridPane, 
								 short item, Box key, short symInx);
								 
	void		BeginTracking (LongPt *startPt);

	void		KeepTracking  (LongPt *currPt, LongPt *prevPt, LongPt *startPt);

};