/******************************************************************************
 CImgWndImage.h

		Interface for the ImageTask Classes
		
		Copyright  1995 Center for Sutton Movement Writing.  All Rights Reserved.
		
 ******************************************************************************/
 
#pragma once

#include "CImgWndTask.h"				/* Interface for its superclass		*/
#include "SymEditConsts.h"
#include "CBitMap.h"



typedef Byte byteMap[IMAP_WIDTH][IMAP_HEIGHT];
typedef byteMap **byteMapHandle;




struct CImageTask : CImgWndTask {	

	Boolean  done;
	
	LongPt	 centerPt;

	byteMapHandle  srcMap;
	byteMapHandle  destMap;
	
	void	IImageTask (short aNameIndex, CImgWndPane *aPane, CBitMap *aBitMap);
	void	Dispose (void);

	short	Round (float val);
	
	void	AlertNoRoom (void);
	
	void	Unpack (BitMapPtr src, byteMap dest);
	void	Pack (byteMap src, BitMapPtr dest);
	
	void	Fill (byteMap map);
	void	Fill2 (byteMap map);	
	
	void	Do (void);
	Boolean Transform (byteMap src, byteMap dest);
	
};


			/*** Classes for Individual Image Commands ***/

struct CInvertVert : CImageTask {
	Boolean		Transform (byteMap src, byteMap dest);
};


struct CInvertHorz : CImageTask {
	Boolean		Transform (byteMap src, byteMap dest);
};


struct CRotate45 : CImageTask {
	Boolean		Transform (byteMap src, byteMap dest);
};


struct CRotate90 : CImageTask {
	Boolean		Transform (byteMap src, byteMap dest);
};


struct CEnlarge50 : CImageTask {
	Boolean		Transform (byteMap src, byteMap dest);
};