
/****
 * CSymWndGrid.h
 *
 *	Symbol window grid class for the SignWriter symbol editor.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/
 
 

#pragma	once					/* Include only once */


#include "CGridSelector.h"
#include "CSymWndCtrl.h"
#include "CSymWndBox.h"
#include "SymEditConsts.h"




struct CSymWndGrid : CGridSelector {

				/* Symbol code */
	short		itsSymCode;
	
	
				/* Current symbol variation */
	short		itsSymVar;
	
	
				/* Image windows */
	void		*itsImgWindow[SGRID_VARS][SGRID_COLS][SGRID_ROWS];
	short		itsImgWindows;

	
				/* Initialization */
	void		ISymWndGrid (CView *anEnclosure, CBureaucrat *aSupervisor,
							  short aWidth, short aHeight,
							  short aHEncl, short aVEncl,
							  SizingOption aHSizing, SizingOption aVSizing,
							  short symCode);

	
				/* Selection */
	void		SelectColumn(short col);
	void		SelectAll(void);
	void		HiliteItem(short theItem, HiliteState state);
	
	
				/* Commands */
	void		DoCopy  (void);
	void		DoPaste (void);
	void		DoClear (short taskIndex);
	
	
				/* Drawing */
	void 		Update (short symVar);
	void		DrawItem (short theItem, Rect *theBox);
	void		UpdateItem (short symVar, short fillVar, short image,
						    BitMap *map, LongRect *area);


				/* Mouse */
	void		DoClick (Point hitPt, short modifierKeys, long when);
	void		DoDoubleClick (void);	


				/* Grid mapping */
	void		ItemToSymImage (short item, short *fillVar, short *image);
	void		SymImageToItem (short fillVar, short image, short *item);
	Boolean 	ValidItem (short theItem); 


				/* Clipboard */
	void		GetRec (short item, void **rec);
	void		SetRec (short item, void *rec);
	void		CopyRec (short item, void *rec, void **copyRec);
	void 		ClearRec (short item, void **rec);
	void		DisposRec (short item, void *rec);

	
				/* Window management */
	void		GetImageWindow (short symVar, short fillVar, short image, void **wind);						  
	void		SetImageWindow (short symVar, short fillVar, short image, void *wind);	
	Boolean		ImageWindowsOpen (void);
					  

				/* Image editing */
	void		NewImageWindow (short fillVar, short image);
	
};
