/****
 * CSymWndLabel.c
 *
 *	Symbol window label methods for the SignWriter symbol editor.
 *
 *  Copyright  1995 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/


#include "CSymWndLabel.h"
#include "SymEditConsts.h"
#include <CPane.h>
#include <BDC.h>


void CSymWndLabel::ISymWndLabel(CView *anEnclosure, CBureaucrat *aSupervisor,
								short aWidth, short aHeight,
								short aHEncl, short aVEncl,
								SizingOption aHSizing, SizingOption aVSizing)
{
	inherited::IPane(anEnclosure, aSupervisor, aWidth, aHeight,
					aHEncl, aVEncl, aHSizing, aVSizing);
}



/***
 * DoClick
 *
 *	Select grid column that corresponds
 *  to the specified label hit point.
 *
 ***/

void CSymWndLabel::DoClick(Point hitPt, short modifierKeys, long when)

{	
	itsSupervisor->DoCommand(cmdSelectCol1 + (hitPt.h / SCELL_WIDTH));
}

					

/***
 * Draw
 *
 *	Draw grid labels that identify the fill
 *  variations of the current symbol.
 *
 ***/

void CSymWndLabel::Draw (Rect *area)

{
	short	coord, labelVal;
	Str15	str;
		
	TextFont(1); TextFace(0); TextSize(10);
	coord = 0;
	for (labelVal = 1; labelVal <= SGRID_COLS; labelVal++) {
		NumToString(labelVal,str);
		MoveTo(coord + ((SCELL_WIDTH - StringWidth(str)) / 2), SLABL_HEIGHT - 4);
		DrawString(str);
		coord += SCELL_WIDTH;
	}
}



/***
 * Dispose
 *
 *	Pass the buck.
 *
 ***/

void CSymWndLabel::Dispose(void)

{
	inherited::Dispose();
}


