/******************************************************************************
 CPatternsDir.c

							The PatternsDir Class
		
	SUPERCLASS = CTearOffMenu
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include <Global.h>
#include <CPatternGrid.h>
#include <CSelectorMDEF.h>
#include "CPatternsDir.h"
#include "ArtClassCmds.h"
#include "CWindow.h"

/*** Global Variables ***/

extern CBureaucrat	*gGopher;			/* First in line to get commands	*/

/*** Class Contstants ***/

#define		WINDpats		1003		/* Resource ID for patterns window	*/


/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 IPatternsDir

		Initialize a PatternsDir object
 ******************************************************************************/

void	CPatternsDir::IPatternsDir(
    CApplication        *aSupervisor)
{
	CPatternGrid	*thePatterns;
	CSelectorMDEF	*theSelectorMDEF;
	short			width;
	short			height;
	Rect			sizeRect;

	CTearOffMenu::ITearOffMenu(aSupervisor, WINDpats);

	itsWindow->SetActClick(TRUE);
							
	thePatterns = new(CPatternGrid);
	thePatterns->IPatternGrid(MENUpatterns, itsWindow, this);
	thePatterns->Activate();
	
										/* Make window same size as Pane	*/
										/*   without lines on the edges		*/
	thePatterns->GetLengths(&width, &height);
	SetRect(&sizeRect, width-1, height-1, width, height);
	itsWindow->SetSizeRect(&sizeRect);
	itsWindow->ChangeSize(width-1, height-1);
	
	itsPane = thePatterns;
	SetRect(&margins, 1, 10, 1, 1);		/* One pixel frame with a 10 pixel	*/
										/*   drag bar on the top side		*/

	theSelectorMDEF = new(CSelectorMDEF);
	theSelectorMDEF->ISelectorMDEF(MENUpatterns, itsPane, this);
	
	itsWindow->MoveOffScreen();			/* Put window out of sight until	*/
	itsWindow->Select();				/*   needed							*/
}
	

/******************************************************************************
 DoCommand {OVERRIDE}

		PatternsDir handles commands corresponding to the selection of
		a Pattern
 ******************************************************************************/

void	CPatternsDir::DoCommand(theCommand)
long		theCommand;
{
	Str255			commandStr;

	if (HiShort(-theCommand) == ((CPatternGrid*)itsPane)->GetCommandBase()) {
										/* Item from Patterns was selected	*/
		gGopher->DoCommand(theCommand);								
	
	} else {
		inherited::DoCommand(theCommand);
	}
}
	

/******************************************************************************
 SelectPattern

		Set the current pattern selection
 ******************************************************************************/

void	CPatternsDir::SelectPattern( short thePat)
{
	itsPane->Prepare();
	((CPatternGrid*)itsPane)->ChangeSelection(thePat);
}
	

/******************************************************************************
 GetPattern

		Return the current pattern
 ******************************************************************************/

void	CPatternsDir::GetPattern( Pattern *thePattern)
{
	((CPatternGrid*)itsPane)->GetPattern(thePattern);
}