
/*
 *  ctype.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

int isalnum(int);
int isalpha(int);
int iscntrl(int);
int isdigit(int);
int isgraph(int);
int islower(int);
int isprint(int);
int ispunct(int);
int isspace(int);
int isupper(int);
int isxdigit(int);
int tolower(int);
int toupper(int);

extern char __ctype[];

#define __CNTL			1
#define __WHIT			2
#define __SPAC			4
#define __PUNC			8
#define __DIGT			16
#define __XDIG			32
#define __UPPR			64
#define __LOWR			128

#define __ctype(c)		__ctype[(int) (unsigned char) (c)]

#define isalnum(c)		(__ctype(c) & (__UPPR|__LOWR|__DIGT))
#define isalpha(c)		(__ctype(c) & (__UPPR|__LOWR))
#define iscntrl(c)		(__ctype(c) & (__CNTL|__WHIT))
#define isdigit(c)		(__ctype(c) & (__DIGT))
#define isgraph(c)		(__ctype(c) & (__UPPR|__LOWR|__DIGT|__PUNC))
#define islower(c)		(__ctype(c) & (__LOWR))
#define isprint(c)		(__ctype(c) & (__UPPR|__LOWR|__DIGT|__PUNC|__SPAC))
#define ispunct(c)		(__ctype(c) & (__PUNC))
#define isspace(c)		(__ctype(c) & (__WHIT|__SPAC))
#define isupper(c)		(__ctype(c) & (__UPPR))
#define isxdigit(c)		(__ctype(c) & (__DIGT|__XDIG))
