
/*
 *  float.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

#define FLT_ROUNDS			1
#define FLT_RADIX			2

#define FLT_MANT_DIG		24
#define FLT_DIG				6
#define FLT_MIN_EXP			(-125)
#define FLT_MIN_10_EXP		(-37)
#define FLT_MAX_EXP			128
#define FLT_MAX_10_EXP		38
#define FLT_MAX				(* (float *) __F_MAX)
#define FLT_EPSILON			(* (float *) __F_EPSILON)
#define FLT_MIN				(* (float *) __F_MIN)

#if __option(double_8)
#define DBL_MANT_DIG		53
#define DBL_DIG				15
#define DBL_MIN_EXP			(-1021)
#define DBL_MIN_10_EXP		(-307)
#define DBL_MAX_EXP			1024
#define DBL_MAX_10_EXP		308
#define DBL_MAX				(* (double *) __D_MAX)
#define DBL_EPSILON			(* (double *) __D_EPSILON)
#define DBL_MIN				(* (double *) __D_MIN)
#else
#define DBL_MANT_DIG		64
#define DBL_DIG				18
#define DBL_MIN_EXP			(-16382)
#define DBL_MIN_10_EXP		(-4931)
#define DBL_MAX_EXP			16384
#define DBL_MAX_10_EXP		4932
#define DBL_MAX				(* (double *) __X_MAX)
#define DBL_EPSILON			(* (double *) __X_EPSILON)
#define DBL_MIN				(* (double *) __X_MIN)
#endif

#define LDBL_MANT_DIG		64
#define LDBL_DIG			18
#define LDBL_MIN_EXP		(-16382)
#define LDBL_MIN_10_EXP		(-4931)
#define LDBL_MAX_EXP		16384
#define LDBL_MAX_10_EXP		4932
#define LDBL_MAX			(* (long double *) __X_MAX)
#define LDBL_EPSILON		(* (long double *) __X_EPSILON)
#define LDBL_MIN			(* (long double *) __X_MIN)

extern short __F_MIN[], __F_MAX[], __F_EPSILON[];
extern short __D_MIN[], __D_MAX[], __D_EPSILON[];
extern short __X_MIN[], __X_MAX[], __X_EPSILON[];
