
/*
 *  atoi.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdlib.h"
#include "stdio.h"


int
atoi(const char *nptr)
{
	int result;
	
	if (sscanf(nptr, "%d", &result) <= 0)
		result = 0;
	return(result);
}


long
atol(const char *nptr)
{
	return(strtol(nptr, NULL, 10));
}


long
strtol(const char *nptr, char **endptr, int base)
{
	long result;
	int count;
	
	if (sscanf(nptr, "%?ld%n", base, &result, &count) <= 0)
		result = count = 0;
	if (endptr)
		*endptr = (char *) nptr + count;
	return(result);
}


unsigned long
strtoul(const char *nptr, char **endptr, int base)
{
	unsigned long result;
	int count;
	
	if (sscanf(nptr, "%?lu%n", base, &result, &count) <= 0)
		result = count = 0;
	if (endptr)
		*endptr = (char *) nptr + count;
	return(result);
}
