
/*
 *  fread.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdio.h"
#include "string.h"
#include "ansi_private.h"

#define INC(ptr, n)			((* (char **) &(ptr)) += (n))


size_t
fread(void *ptr, size_t size, size_t count, FILE *fp)
{
	register size_t nbytes = size * count, n;
	int err, c;
	
	if (nbytes == 0)
		return(0);
	__checkfile(fp);
	do {
	
			/*  read pushed-back byte  */
	
		if (fp->pushed) {
			if ((c = getc(fp)) == EOF)
				break;
			* (char *) ptr = c;
			n = 1;
		}
				
			/*  read whole blocks from file  */
		
		else if (fp->refnum > 0 && fp->cnt == 0 && nbytes >= fp->size
		&& (fp->size == 1 || (fp->pos % fp->size == 0))) {
			n = nbytes;
			if (fp->size > 1)
				n -= n % fp->size;
			fp->ptr = ptr;
			fp->pos += fp->cnt = n;
			err = __read(fp);
			n = fp->cnt;
			__reset(fp);
			if (err)
				break;
		}
	
			/*  read from buffer  */
		
		else {
			if (fp->cnt == 0) {
				__buffer(fp);
				if (__read(fp))
					break;
			}
			if ((n = fp->cnt) > nbytes)
				n = nbytes;
			memcpy(ptr, fp->ptr, n);
			fp->ptr += n;
			fp->cnt -= n;
		}
		
			/*  done with this pass  */
		
		INC(ptr, n);
	} while (nbytes -= n);
	
		/*  done  */
		
	if (nbytes)
		count -= (nbytes + size - 1) / size;
	return(count);
}
