
/*
 *  fwrite.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdio.h"
#include "string.h"
#include "ansi_private.h"

#define INC(ptr, n)			((* (char **) &(ptr)) += (n))


size_t
fwrite(const void *ptr, size_t size, size_t count, FILE *fp)
{
	register size_t nbytes = size * count, n;
	int err;
	
	if (nbytes == 0)
		return(0);
	__checkfile(fp);
	if (fp->append && !fp->dirty)
		fp->pos = fp->len;
	do {

			/*  write whole blocks to binary file  */
		
		if (fp->refnum > 0 && fp->binary && fp->cnt == 0 && nbytes >= fp->size
		&& (fp->size == 1 || (fp->pos % fp->size == 0))) {
			n = nbytes;
			if (fp->size > 1)
				n -= n % fp->size;
			fp->ptr = (void *) ptr;
			fp->pos += fp->cnt = n;
			err = __write(fp);
			__reset(fp);
			if (err)
				break;
		}
		
			/*  putc to console or "clean" buffer  */

		else if (!fp->dirty || fp->window) {
			if (putc(* (char *) ptr, fp) == EOF)
				break;
			n = 1;
		}
	
			/*  write to buffer  */
		
		else {
			if ((n = fp->cnt) > nbytes)
				n = nbytes;
			memcpy(fp->ptr, ptr, n);
			fp->ptr += n;
			if ((fp->cnt -= n) == 0 && __flush(fp))
				break;
		}
		
			/*  done with this pass  */
		
		INC(ptr, n);
	} while (nbytes -= n);
	
		/*  done  */
		
	if (nbytes)
		count -= (nbytes + size - 1) / size;
	return(count);
}
