
/*
 *  mb/wc.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdlib.h"


int
mblen(const char *s, size_t n)
{
	return(mbtowc(NULL, s, n));
}


int
mbtowc(wchar_t *pwc, const char *s, size_t n)
{
	if (s) {
		if (n == 0)
			return(-1);
		if (pwc)
			*pwc = *s;
		if (*s)
			return(1);
	}
	return(0);
}


int wctomb(char *s, wchar_t wchar)
{
	if (s) {
		*s = wchar;
		return(1);
	}
	return(0);
}


size_t
mbstowcs(wchar_t *pwcs, const char *s, size_t n)
{
	size_t i;
	
	for (i = 0; i < n && (*pwcs++ = *s++); i++)
		;
	return(i);
}


size_t
wcstombs(char *s, const wchar_t *pwcs, size_t n)
{
	size_t i;
	
	for (i = 0; i < n && (*s++ = *pwcs++); i++)
		;
	return(i);
}
