
/*
 *  SANE.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 *
 */

#include <SANE.h>


union env {
	environment word;
	struct { int : 1, dir : 2, : 6, pre : 2; } bits;
};


void
procentry(environment *e)
{
	fp68k(e, FPROCENTRY);
}


void
procexit(environment e)
{
	fp68k(&e, FPROCEXIT);
}


void
getenvironment(environment *e)
{
	fp68k(e, FGETENV);
}


void
setenvironment(environment e)
{
	fp68k(&e, FSETENV);
}


long
testexception(environment e)
{
	return(testhalt(e << 8));
}


void
setexception(environment e, long s)
{
	environment env;
	
	e <<= 8;
	if (!s)
		sethalt(e, s);
	else {
		fp68k(&env, FGETENV);
		fp68k(&e, FSETENV);
		fp68k(&env, FPROCEXIT);
	}
}


long
testhalt(exception e)
{
	environment env;
	
	fp68k(&env, FGETENV);
	return((env & e) != 0);
}


void
sethalt(exception e, long s)
{
	environment env;
	
	fp68k(&env, FGETENV);
	if (s)
		env |= e;
	else
		env &= ~e;
	fp68k(&env, FSETENV);
}


haltvector
gethaltvector(void)
{
	haltvector v;
	
	fp68k(&v, FGETHV);
	return(v);
}


void
sethaltvector(haltvector v)
{
	fp68k(&v, FSETHV);
}


roundpre
getprecision(void)
{
	union env env;
	
	fp68k(&env.word, FGETENV);
	return(env.bits.pre);
}


void
setprecision(roundpre p)
{
	union env env;
	
	fp68k(&env.word, FGETENV);
	env.bits.pre = p;
	fp68k(&env.word, FSETENV);
}


rounddir
getround(void)
{
	union env env;
	
	fp68k(&env.word, FGETENV);
	return(env.bits.dir);
}


void
setround(rounddir d)
{
	union env env;
	
	fp68k(&env.word, FGETENV);
	env.bits.dir = d;
	fp68k(&env.word, FSETENV);
}
