
/*
 *  SANE.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 *
 */

#include <SANE.h>


extended
nextextended(extended x, extended y)
{
	fp68k(&x, &y, FNEXTX);
	return(x);
}


extended
nextdouble(extended x, extended y)
{
	double xx, yy;
	
	fp68k(&x, &xx, FX2D);
	fp68k(&y, &yy, FX2D);
	fp68k(&xx, &yy, FNEXTD);
	fp68k(&xx, &x, FD2X);
	return(x);
}


extended
nextfloat(extended x, extended y)
{
	float xx, yy;
	
	fp68k(&x, &xx, FX2S);
	fp68k(&y, &yy, FX2S);
	fp68k(&xx, &yy, FNEXTS);
	fp68k(&xx, &x, FS2X);
	return(x);
}


numclass
classextended(extended x)
{
	short n;
	
	fp68k(&x, &n, FCLASSX);
	return(n < 0 ? ~n : n - 1);
}


numclass
classdouble(extended x)
{
	double xx;
	short n;
	
	fp68k(&x, &xx, FX2D);
	fp68k(&xx, &n, FCLASSD);
	return(n < 0 ? ~n : n - 1);
}


numclass
classfloat(extended x)
{
	float xx;
	short n;

	fp68k(&x, &xx, FX2S);
	fp68k(&xx, &n, FCLASSS);
	return(n < 0 ? ~n : n - 1);
}


long
signnum(extended x)
{
	short n;
	
	fp68k(&x, &n, FCLASSX);
	return(n < 0);
}


relop
relation(extended x, extended y)
{
	fp68k(&y, &x, FCMPX);
	asm {
		movea.w	#UNORDERED,a0
		bvs.s	@3
		beq.s	@2
		blt.s	@1
		subq.w	#1,a0
@1		subq.w	#1,a0
@2		subq.w	#1,a0
@3		move.l	a0,d0
	}
}


extended
copysign(extended x, extended y)
{
	y.exp[0] &= 0x7FFF;
	if (x.exp[0] < 0)
		y.exp[0] |= 0x8000;
	return(y);
}
