/******************************************************************************
 CStaticText.c

							The StaticText Class
		
	SUPERCLASS = CPanorama
	
	Copyright  1989 Symantec Corporation. All rights reserved.

	TCL 1.1 CHANGES
	[
		CStaticText is now a subclass of CEditText. Since CEditText
		has options for specifying if it is editable and selectable,
		CStaticText requires no code other than an initialization
		method. 
	]
	
 ******************************************************************************/

#include "CStaticText.h"



/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 IStaticText

		Initialize a StaticText object
 ******************************************************************************/

void	CStaticText::IStaticText(
	CView			*anEnclosure,
	CBureaucrat		*aSupervisor,
	short			aWidth,
	short			aHeight,
	short			aHEncl,
	short			aVEncl,
	SizingOption	aHSizing,
	SizingOption	aVSizing,
	short			aLineWidth)
{
	CEditText::IEditText(anEnclosure, aSupervisor,
					aWidth, aHeight, aHEncl, aVEncl, aHSizing, aVSizing,
					aLineWidth);
					
	Specify( kNotEditable, kNotSelectable, kNotStylable);
}
	
