/******************************************************************************
 Jumps.c
 
 	Jump Utilties
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

short	f_SetJump(void);
void	f_LongJump(void);


/*=============================================================================
 f_SetJump

		Save the current stack environment and return zero.
 =============================================================================*/

short	f_SetJump()
/*
JumpBuffer		theJumpBuffer;
*/
{
	asm {
		moveq	#0,d0					/* Set return value of zero			*/
		movea.l	(sp)+,a1				/* Save return address				*/
		movea.l	(sp),a0					/* Get pointer to buffer			*/
		movem.l	d3-d7/a1-a4/a6-a7,(a0)	/* Save registers in buffer			*/
		jmp		(a1)					/* Resume at return address			*/
	}
}


/*=============================================================================
 f_LongJump

		Perform a non-local goto by restoring a stack state saved by a
		previous call to f_SetJump(). Program execution continues as
		if the original call to f_SetJump() had just returned returnVal.
 =============================================================================*/

void	f_LongJump()
/*
JumpBuffer		theJumpBuffer;
short			returnVal;
*/
{
	asm {
		addq.l	#4,sp					/* Discard return address			*/
		movea.l	(sp)+,a0				/* Get pointer to buffer			*/
		move.w	(sp),d0					/* Get return value					*/
		bne.s	@1						/* If return value is zero ...		*/
		moveq	#1,d0					/*   Make it a one					*/
@1		movem.l	(a0),d3-d7/a1-a4/a6-a7	/* Restore registers from buffer	*/
		jmp		(a1)					/* Resume at f_SetJump return addr	*/
	}
}
