/******************************************************************************
 CAppleEvent.h

		Interface for the AppleEvent Class
		
		Copyright  1991 Symantec Corporation. All rights reserved.
		
 ******************************************************************************/

#define _H_CAppleEvent

#include "CObject.h"
#include "AppleEvents.h"

class CArray;
struct NMRec;

class CAppleEvent : public CObject
{
public:

	void IAppleEvent( const AppleEvent *theEvent, const AppleEvent *theReply,
					long theRefCon, DescType eventClass, DescType eventID);
									
	virtual DescType GetEventClass( void);
	virtual DescType GetEventID( void);
	
	virtual AppleEvent GetAEEvent( void);
	virtual AppleEvent GetAEReply( void);
	virtual long GetAERefCon( void);
	
	virtual void GetDescList( AEKeyword whichParam, AEDescList *descList);
	virtual CArray *ExtractFromDescList( AEKeyword whichParam, DescType itemType,
					Size itemSize); 
	
	virtual Boolean GotRequiredParams( void);
	
	virtual OSErr	RequestInteraction( long timeOutTicks);
	
	virtual void	SetErrorResult( OSErr anErrorCode);
	virtual OSErr 	GetErrorResult( void);
					
protected:

	AppleEvent	theEvent;
	AppleEvent	theReply;
	long		theRefCon;
	
	DescType	eventClass;
	DescType	eventID;

	Boolean		canInteract;
	OSErr		errCode;
	
	struct NMRec* notificationRec;		// used for AEInteractWithUser. default is NULL
	IdleProcPtr idleProc;				// idle proc for AEInteractWithUser. If NULL,
										// use's CSwitchboard's idle proc
	
};