/******************************************************************************
 CFile.h

		Interface for the File Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- changed interface of all methods returning OSErr to void. These
			methods now use the exception mechanism to report failure. If
			you need or prefer the old interface, use the compatibility
			class BFile.
		- added ExistsOnDisk, GetMacFileInfo, SpecifyFSSpec, GetFSSpec,
		  and ResolveFileAlias methods
	]
	
 ******************************************************************************/
 
#define _H_CFile

#include "CObject.h"					/* Interface for its superclass		*/
#include "Global.h"

class CFile : public CObject {				/* Class Declaration				*/

public:
								/** Instance Variables **/
	Str63		name;					/* File name						*/
	short		volNum;					/* Volume containing the file		*/
	long		dirID;					/* Directory within the volume		*/

								/** Instance Methods **/
									/** Construction/Destruction **/
	void		IFile(void);
	virtual void		Dispose(void);
									
									/** Specifying **/
	virtual void		Specify(Str63 aName, short aVolNum);
	virtual void		SpecifyHFS(Str63 aName, short aVolNum, long aDirID);
	virtual void		SFSpecify(SFReply *macSFReply);
	virtual void		SpecifyFSSpec( const FSSpec * aFileSpec);
	
	virtual void		ResolveFileAlias( void);
	
									/** Open/Close **/
	virtual void		Open(SignedByte permission);
	virtual void		Close(void);
	
									/** Accessing **/
	virtual Boolean		ExistsOnDisk( void);
	virtual void		GetName(Str63 theName);
	virtual void		GetMacFileInfo( FInfo *fileInfo);
	virtual void		GetFSSpec( FSSpec *aFileSpec);
	
									/** Filing **/
	virtual void		CreateNew(OSType creator, OSType fType);
	virtual void		ThrowOut(void);
	virtual void		ChangeName(Str63 newName);
};