/******************************************************************************
 CEnvironment.c

							The Environment Class
	
	Maintains information about the drawing environment for a Pane so that
	it can be restored whenever the Pane needs to be drawn. This class
	merely restores the normal pen characteristics. Subclasses should be
	created if a program uses Panes which require particular settings,
	such as text characteristics or color settings.
		
	SUPERCLASS = CObject
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CEnvironment.h"
	

/******************************************************************************
 Restore

		Restore the state of the Environment. The port must be properly
		set before calling this method.
 ******************************************************************************/

void	CEnvironment::Restore()
{
	PenNormal();						/* Set default pen state			*/
}