/******************************************************************************
 CDialogText.h
 
 		Interface for DialogText class/

		
	SUPERCLASS = 
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CDialogText

#include "CEditText.h"

class CDialog;

class CDialogText : public CEditText
{	
public:

	
	void 		IDialogText(CView *anEnclosure, CView *aSupervisor,
					short aWidth, short aHeight,
					short aHEncl, short aVEncl,
					SizingOption aHSizing, SizingOption aVSizing,
					short aLineWidth);	
	virtual void 	IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);
	virtual void 	SetConstraints( Boolean fRequired, long aMaxChars);

	virtual void 	DoKeyDown( char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void 	GetTextString( StringPtr aString);
	virtual Boolean Validate( void);
	virtual Boolean	BecomeGopher( Boolean fBecoming);
	
protected:

	Boolean		isRequired : 1;			// TRUE if must be non-empty to be valid
	Boolean		validateOnResign : 1;	// TRUE if validate on resigning gopher
	long		maxValidLength;			// maximum number of chars for validation
	
	virtual void ReportInvalidText( short strIndex);
	virtual void 	MakeBorder( void);
	void 			IDialogTextX( void);
};

				/* indices into STR# 133 for validation constrain errors	*/
	
#define		validateFieldIsRequired		1			/* required field was left blank	*/
#define		validateFieldTooLong		2			/* field's length exceeds its maximum */

/* Change propagation constants for CDialogText */

enum
{
			/* indicates the text has changed in some way 		*/
			/* info parameter is pointer (short*) to pane ID	*/
	dialogTextChanged = bureaucratLastChange + 1,
	
	dialogTextLastChange = dialogTextChanged
};

/* View Template for DialogText */

typedef struct tDialogTextTemp
{
	tAbstractTextTemp	absTextTmp;
	short			fRequired;
	short			fValidateOnResign;
	long			maxLength;
	
} tDialogTextTemp, *tDialogTextTempP;