/******************************************************************************
 CBitMap.h

		Interface for the BitMap Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
 ******************************************************************************/
 
#define _H_CBitMap

#include "CObject.h"					/* Interface for its superclass		*/
#include "LongCoordinates.h"

class CBitMap : public CObject {		/* Class Declaration				*/

public:
								/** Instance Variables **/
	GrafPtr		macPort;
	GrafPtr		savePort;
	BitMap		*macBitMap;
	BitMap		saveBitMap;
	short		xferMode;

								/** Instance Methods **/
									/** Contruction/Destruction **/
	void		IBitMap(short width, short height, Boolean makePort);
	virtual void		Dispose(void);
	
									/** Accessing **/
	virtual void		GetBounds(LongRect *theBounds);
	virtual void		SetBoundsOrigin(short hOrigin, short vOrigin);
	virtual void		SetXferMode(short aXferMode);
	virtual short		GetXferMode(void);
	virtual Boolean		PixelIsBlack(LongPt *pixelPos);
	
									/** Image Copying **/
	virtual void		CopyTo(LongRect *fromRect, LongRect *toRect, RgnHandle maskRgn);
	virtual void		CopyFrom(LongRect *fromRect, LongRect *toRect, RgnHandle maskRgn);
	
									/** Preparing **/
	virtual void		BeginDrawing(void);
	virtual void		EndDrawing(void);
};