/******************************************************************************
 LongCoordinates.h

		
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_LongCoordinates


typedef struct LongPt
{
	long	v, h;

} LongPt, *LongPtPtr, **LongPtHndl;

typedef struct LongRect
{
	long top, left, bottom, right;
	
} LongRect, *LongRectPtr, **LongRectHndl;

	// access top left and bottom right LongPt of a LongRect
#define topLeftL(r)		(((LongPt *) &(r))[0])
#define botRightL(r)	(((LongPt *) &(r))[1])

	/*
	 *	LongPt utilities
	 *
	 */
	 
pascal void		QDToLongPt( Point srcPt, LongPt *destPt);
pascal void		LongToQDPt( LongPt *srcPt, Point *destPt);
pascal void 	SetLongPt( LongPt *pt, long h, long v);
pascal void		AddLongPt( LongPt *srcPt, LongPt *destPt);
pascal void		SubLongPt( LongPt *srcPt, LongPt *destPt);
pascal Boolean	EqualLongPt( LongPt *pt1, LongPt *pt2);
pascal Boolean	PtInQDSpace( LongPt *pt);


	/*
	 *	LongRect utilities
	 *
	 */


pascal void		QDToLongRect( Rect *srcRect, LongRect *destRect);
pascal void		LongToQDRect( LongRect *srcRect, Rect *destRect);
pascal void 	SetLongRect( LongRect *r, long left, long top, long right, long bottom);
pascal void 	OffsetLongRect( LongRect *r, long dh, long dv);
pascal void 	InsetLongRect( LongRect *r, long dh, long dv);
pascal Boolean 	SectLongRect( LongRect *src1, LongRect *src2, LongRect *destRect);
pascal void 	UnionLongRect( LongRect *src1, LongRect *src2, LongRect *destRect);
pascal Boolean 	PtInLongRect( LongPt *pt, LongRect *r);
pascal void 	Pt2LongRect( LongPt *pt1, LongPt *pt2, LongRect *r);
pascal Boolean	EqualLongRect( LongRect *r1, LongRect *r2);
pascal Boolean	EmptyLongRect( LongRect *r);
pascal Boolean	RectInQDSpace( LongRect *r);