/******************************************************************************
 CTextStyleTask.h

		Interface for text styling task
		
	SUPERCLASS = CTask
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CTextStyleTask

#include "CTask.h"

		// style modes used by CTextStyleTask in addition to those that
		// are defined in TextEdit.h
		
#define		doAlign		32		// change text alignment
#define 	doSpacing	64		// change line spacing

class CAbstractText;

class CTextStyleTask : public CTask
{
public:

	void ITextStyleTask( CAbstractText *aTextPane, long aStyleCmd, short taskIndex);

	virtual void Dispose( void);
	
	virtual void Do( void);
	virtual void Undo( void);

protected:

	CAbstractText		*itsTextPane;	// target text pane
	TextStyle			oldStyle;		// original style before command
	long				oldAlignCmd;	// original alignment before command
	long				oldSpacingCmd;	// original spacing before command
	long				styleCmd;		// command that initiated this task
	short				styleAttribute;	// style attributes affected by this task
	
	virtual void SaveStyle( void);
	virtual void RestoreStyle( void);

};